=== modified file '.bzrignore'
--- .bzrignore	2006-10-09 16:47:57 +0000
+++ .bzrignore	2006-10-14 10:26:00 +0000
@@ -4,3 +4,4 @@
 *.pyc
 *.bak
 *.gladep
+dist

=== added file 'Makefile'
--- Makefile	1970-01-01 00:00:00 +0000
+++ Makefile	2006-10-10 08:07:27 +0000
@@ -0,0 +1,5 @@
+python-installer:
+	python setup.py bdist_wininst
+
+clean:
+	python -c "import shutil; shutil.rmtree('build'); shutil.rmtree('dist')"

=== modified file 'olive-gtk'
--- olive-gtk	2006-09-06 00:23:46 +0000
+++ olive-gtk	2006-10-05 13:44:08 +0000
@@ -56,6 +56,29 @@
 import gettext
 gettext.install('olive-gtk')
 
+
+# make sure we could import bzrlib
+try:
+    import bzrlib
+except ImportError:
+    # try to find bzr if it exist in $PATH
+    p = os.popen('bzr version')
+    s = p.read()
+    r = p.close()
+    if r not in (None, 0):
+        print >>sys.stderr, "bzr not found"
+        sys.exit(1)
+    else:
+        for i in s.splitlines():
+            if i.startswith("Using bzrlib: "):
+                path = os.path.split(i[14:])[0]
+                sys.path.append(path)
+                break
+        else:
+            print >>sys.stderr, "Can't find bzrlib location"
+            sys.exit(1)
+
+
 from olive import OliveGtk
 from bzrlib.plugin import load_plugins
 load_plugins()

=== modified file 'olive.glade'
--- olive.glade	2006-10-09 21:21:47 +0000
+++ olive.glade	2006-10-14 10:26:00 +0000
@@ -235,7 +235,7 @@
 		      <child internal-child="image">
 			<widget class="GtkImage" id="image243">
 			  <property name="visible">True</property>
-			  <property name="pixbuf">pull16.png</property>
+			  <property name="pixbuf">icons/pull16.png</property>
 			  <property name="xalign">0.5</property>
 			  <property name="yalign">0.5</property>
 			  <property name="xpad">0</property>
@@ -255,7 +255,7 @@
 		      <child internal-child="image">
 			<widget class="GtkImage" id="image244">
 			  <property name="visible">True</property>
-			  <property name="pixbuf">push16.png</property>
+			  <property name="pixbuf">icons/push16.png</property>
 			  <property name="xalign">0.5</property>
 			  <property name="yalign">0.5</property>
 			  <property name="xpad">0</property>
@@ -290,7 +290,7 @@
 		      <child internal-child="image">
 			<widget class="GtkImage" id="image245">
 			  <property name="visible">True</property>
-			  <property name="pixbuf">commit16.png</property>
+			  <property name="pixbuf">icons/commit16.png</property>
 			  <property name="xalign">0.5</property>
 			  <property name="yalign">0.5</property>
 			  <property name="xpad">0</property>
@@ -347,7 +347,7 @@
 		      <child internal-child="image">
 			<widget class="GtkImage" id="image246">
 			  <property name="visible">True</property>
-			  <property name="pixbuf">diff16.png</property>
+			  <property name="pixbuf">icons/diff16.png</property>
 			  <property name="xalign">0.5</property>
 			  <property name="yalign">0.5</property>
 			  <property name="xpad">0</property>
@@ -367,7 +367,7 @@
 		      <child internal-child="image">
 			<widget class="GtkImage" id="image247">
 			  <property name="visible">True</property>
-			  <property name="pixbuf">log16.png</property>
+			  <property name="pixbuf">icons/log16.png</property>
 			  <property name="xalign">0.5</property>
 			  <property name="yalign">0.5</property>
 			  <property name="xpad">0</property>
@@ -432,7 +432,7 @@
 	      <property name="visible">True</property>
 	      <property name="label" translatable="yes">Refresh</property>
 	      <property name="use_underline">True</property>
-	      <property name="icon">refresh.png</property>
+	      <property name="icon">icons/refresh.png</property>
 	      <property name="visible_horizontal">True</property>
 	      <property name="visible_vertical">True</property>
 	      <property name="is_important">False</property>
@@ -449,7 +449,7 @@
 	      <property name="visible">True</property>
 	      <property name="label" translatable="yes">Diff</property>
 	      <property name="use_underline">True</property>
-	      <property name="icon">diff.png</property>
+	      <property name="icon">icons/diff.png</property>
 	      <property name="visible_horizontal">True</property>
 	      <property name="visible_vertical">True</property>
 	      <property name="is_important">False</property>
@@ -466,7 +466,7 @@
 	      <property name="visible">True</property>
 	      <property name="label" translatable="yes">Log</property>
 	      <property name="use_underline">True</property>
-	      <property name="icon">log.png</property>
+	      <property name="icon">icons/log.png</property>
 	      <property name="visible_horizontal">True</property>
 	      <property name="visible_vertical">True</property>
 	      <property name="is_important">False</property>
@@ -496,7 +496,7 @@
 	      <property name="visible">True</property>
 	      <property name="label" translatable="yes">Commit</property>
 	      <property name="use_underline">True</property>
-	      <property name="icon">commit.png</property>
+	      <property name="icon">icons/commit.png</property>
 	      <property name="visible_horizontal">True</property>
 	      <property name="visible_vertical">True</property>
 	      <property name="is_important">False</property>
@@ -526,7 +526,7 @@
 	      <property name="visible">True</property>
 	      <property name="label" translatable="yes">Pull</property>
 	      <property name="use_underline">True</property>
-	      <property name="icon">pull.png</property>
+	      <property name="icon">icons/pull.png</property>
 	      <property name="visible_horizontal">True</property>
 	      <property name="visible_vertical">True</property>
 	      <property name="is_important">False</property>
@@ -543,7 +543,7 @@
 	      <property name="visible">True</property>
 	      <property name="label" translatable="yes">Push</property>
 	      <property name="use_underline">True</property>
-	      <property name="icon">push.png</property>
+	      <property name="icon">icons/push.png</property>
 	      <property name="visible_horizontal">True</property>
 	      <property name="visible_vertical">True</property>
 	      <property name="is_important">False</property>

=== modified file 'olive/__init__.py'
--- olive/__init__.py	2006-10-09 21:21:47 +0000
+++ olive/__init__.py	2006-10-14 10:26:00 +0000
@@ -45,8 +45,9 @@
     gladefile = "/usr/share/olive/olive.glade"
 
 if not os.path.exists(gladefile):
-    # Load from current directory if not installed
-    gladefile = "olive.glade"
+    # Load from sources directory if not installed
+    dir_ = os.path.split(os.path.dirname(__file__))[0]
+    gladefile = os.path.join(dir_, "olive.glade")
     # Check again
     if not os.path.exists(gladefile):
         # Fail
@@ -188,7 +189,7 @@
         self.notbranch = False
         try:
             self.wt, self.wtpath = WorkingTree.open_containing(self.path)
-        except errors.NotBranchError:
+        except (errors.NotBranchError, errors.NoWorkingTree):
             self.notbranch = True
 
     def get_path(self):
@@ -276,10 +277,7 @@
         #    tree_to.pull(branch_from)
         #else:
         #    branch_to.pull(branch_from)
-        branch_to.pull(branch_from)
-        
-        # TODO: get the number of pulled revisions
-        ret = 0
+        ret = branch_to.pull(branch_from)
         
         info_dialog(_('Pull successful'), _('%d revision(s) pulled.') % ret)
     
@@ -438,8 +436,6 @@
     def on_treeview_right_row_activated(self, treeview, path, view_column):
         """ Occurs when somebody double-clicks or enters an item in the
         file list. """
-        import os.path
-        
         from launch import launch
         
         newdir = self.get_selected_right()
@@ -447,7 +443,7 @@
         if newdir == '..':
             self.set_path(os.path.split(self.get_path())[0])
         else:
-            fullpath = self.get_path() + os.sep + newdir
+            fullpath = os.path.join(self.get_path(), newdir)
             if os.path.isdir(fullpath):
                 # selected item is an existant directory
                 self.set_path(fullpath)
@@ -497,12 +493,33 @@
         # Expand the tree
         self.treeview_left.expand_all()
 
+    def _add_updir_to_dirlist(self, dirlist, curdir):
+        """Add .. to the top of directories list if we not in root directory
+
+        @param  dirlist:    list of directories (modified in place)
+        @param  curdir:     current directory
+        @return:            nothing
+        """
+        if curdir is None:
+            curdir = self.path
+
+        if sys.platform == 'win32':
+            drive, tail = os.path.splitdrive(curdir)
+            if tail in ('', '/', '\\'):
+                return
+        else:
+            if curdir == '/':
+                return
+
+        # insert always as first element
+        dirlist.insert(0, '..')
+
     def _load_right(self):
         """ Load data into the right panel. (Filelist) """
         # Create ListStore
         liststore = gtk.ListStore(str, str, str)
         
-        dirs = ['..']
+        dirs = []
         files = []
         
         # Fill the appropriate lists
@@ -518,6 +535,9 @@
         # Sort'em
         dirs.sort()
         files.sort()
+
+        # add updir link to dirs
+        self._add_updir_to_dirlist(dirs, self.path)
         
         if not self.notbranch:
             branch = self.wt.branch
@@ -679,7 +699,7 @@
         liststore = self.treeview_right.get_model()
         liststore.clear()
 
-        dirs = ['..']
+        dirs = []
         files = []
 
         # Fill the appropriate lists
@@ -695,12 +715,15 @@
         # Sort'em
         dirs.sort()
         files.sort()
-        
+
+        # add updir link to dirs
+        self._add_updir_to_dirlist(dirs, path)
+
         # Try to open the working tree
         notbranch = False
         try:
             tree1 = WorkingTree.open_containing(path)[0]
-        except errors.NotBranchError:
+        except (errors.NotBranchError, errors.NoWorkingTree):
             notbranch = True
         except errors.PermissionDenied:
             print "DEBUG: permission denied."
@@ -789,6 +812,7 @@
         active = combobox.get_active()
         if active >= 0:
             drive = model[active][0]
+            self.set_path(drive + '\\')
             self.refresh_right(drive + '\\')
 
 import ConfigParser

=== modified file 'olive/menu.py'
--- olive/menu.py	2006-10-04 19:11:46 +0000
+++ olive/menu.py	2006-10-14 10:26:00 +0000
@@ -149,7 +149,7 @@
             return
         
         try:
-            bzrlib.add.smart_add([directory + '/' + filename])
+            bzrlib.add.smart_add([os.path.join(directory, filename)])
         except errors.NotBranchError:
             error_dialog(_('Directory is not a branch'),
                          _('You can perform this action only in a branch.'))

=== modified file 'olive/push.py'
--- olive/push.py	2006-09-30 13:04:15 +0000
+++ olive/push.py	2006-10-05 15:16:58 +0000
@@ -65,7 +65,7 @@
         self.check_remember.set_sensitive(0)
         self.check_create.set_sensitive(0)
         
-        self.entry_stored.set_text(branch.get_push_location())
+        self.entry_stored.set_text(branch.get_push_location() or '')
     
     def display(self):
         """ Display the Push dialog. """

=== modified file 'setup.py'
--- setup.py	2006-09-30 10:21:43 +0000
+++ setup.py	2006-10-14 10:26:00 +0000
@@ -69,6 +69,8 @@
       data_files=[('share/olive', ['olive.glade',
                                    'oliveicon2.png',
                                    'cmenu.ui',
+                                  ]),
+                  ('share/olive/icons', [\
                                    'icons/commit.png',
                                    'icons/commit16.png',
                                    'icons/diff.png',

